//+=======================+
//| Teamspeak + Blockland |
//|     It does stuff     |
//+=======================+

$TS::chatMessages = 1;

function teamspeakCon::onDisconnect(%this)
{
	echo("Disconnected from Teamspeak3 Client. Reconnecting...");
	teamspeakCon.schedule(1000, connect, "localhost:25639");
}
function teamspeakCon::onConnected(%this)
{
	echo("Connection to Teamspeak3 Client succeeded.");
	%this.schedule(100,com,"serverconnectinfo");
}
function teamspeakCon::onConnectFailed(%this)
{
	warn("Connection to Teamspeak3 Client failed!");
	//warn("Do you have ClientQuery enabled? Or are even running Teamspeak 3?");
	teamspeakMM.setBitmap("Add-ons/Client_Teamspeak/failed");
	schedule(1000,0,resetTSButton);
}

function resetTSButton()
{
	teamspeakMM.enabled = 1;
	teamspeakMM.setBitmap("Add-ons/Client_Teamspeak/connect");
}

function teamspeakCon::onLine(%this, %line)
{
	$lastline = %line;
	switch$(getWord(%line,0))
	{
	case "\rerror":
		if(!(getWord(%line,1) $="id=0"))
		{
				warn("Teamspeak Client error \"" @ %line @ "\"");
		}
		return;
	case "\rnotifytalkstatuschange":
		setTeamspeakTalk(strReplace(getWord(%line,4),"clid=",""),strReplace(getWord(%line,2),"status=","")); //clientID, isTalking
	case "\rnotifytextmessage":
		if(strPos(getWord(%line,5),"invokername=") != -1)
			teamspeakMessage(strReplace(getWord(%line,5),"invokername=",""),strReplace(getWord(%line,3),"msg=",""),0); //clientName, message
		else
			teamspeakMessage(strReplace(getWord(%line,6),"invokername=",""),strReplace(getWord(%line,3),"msg=",""),1);
	case "\rnotifychannelcreated":
		%this.schedule(100,com,"channellist");
	case "\rnotifychanneldeleted":
		%this.schedule(100,com,"channellist");
	case "\rnotifychanneledited":
		%this.schedule(100,com,"channellist");
	case "\rnotifychannelmoved":
		%this.schedule(100,com,"channellist");
	case "\rnotifyclientleftview":
		%this.schedule(100,com,"clientlist");
	case "\rnotifycliententerview":
		%this.schedule(100,com,"clientlist");
	}
	
	if(%this.curCom $= "channellist")
		buildChannelList(%line);
	if(%this.curCom $= "clientlist")
		buildClientList(%line);
	if(%this.curCom $= "serverconnectinfo")
	{
		teamspeakMM.setBitmap("Add-ons/Client_Teamspeak/connected");
		teamspeakMM.enabled = 0;
		%this.callbackEvents();
		%this.schedule(100,com,"channellist");
		%this.schedule(200,com,"clientlist");
	}
	%this.curCom = "";
}
function teamspeakCon::com(%this,%com)
{
	%this.curCom = %com;
	%this.send(%com @ "\n");
}
function teamspeakCon::callbackEvents(%this)
{
	%this.com("clientnotifyregister schandlerid=0 event=notifytalkstatuschange");
	%this.com("clientnotifyregister schandlerid=0 event=notifytextmessage");
	%this.com("clientnotifyregister schandlerid=0 event=notifychannelcreated");
	%this.com("clientnotifyregister schandlerid=0 event=notifychanneldeleted");
	%this.com("clientnotifyregister schandlerid=0 event=notifychanneledited");
	%this.com("clientnotifyregister schandlerid=0 event=notifychannelmoved");
	%this.com("clientnotifyregister schandlerid=0 event=notifyclientleftview");
	%this.com("clientnotifyregister schandlerid=0 event=notifycliententerview");
	%this.com("clientnotifyregister schandlerid=0 event=notifyconnectioninfo");
}

function initTeamspeakCon()
{
	new TCPObject(teamspeakCon);
	teamspeakCon.connect("localhost:25639");
	
	new GuiBitmapButtonCtrl(teamspeakMM)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "150 50";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		text = "";
		groupNum = "-1";
		buttonType = "PushButton";
		lockAspectRatio = "0";
		alignLeft = "0";
		alignTop = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
		bitmap = "Add-ons/Client_Teamspeak/connect";
		command = "teamspeakConnect();";
	};
	teamspeakMM.position = getWord(getRes(),0)/2 - 75 SPC getWord(getRes(),1) - 100;
	MainMenuGUI.add(teamspeakMM);
	
	%gui = new GuiBitmapCtrl() {
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "450 175";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		wrap = "0";
		lockAspectRatio = "0";
		alignLeft = "0";
		alignTop = "0";
		overflowImage = "0";
		keepCached = "0";
		mColor = "255 255 255 255";
		mMultiply = "0";
		bitmap = "Add-ons/Client_Teamspeak/tslogo.png";
	};
	%gui.position = getWord(getRes(),0)/2 - 225 SPC getWord(getRes(),1) - 275;
	MainMenuGUI.add(%gui);

	new GuiSwatchCtrl(TeamspeakTalking) {
	   profile = "GuiDefaultProfile";
	   horizSizing = "right";
	   vertSizing = "bottom";
	   position = "0 0";
	   extent = "200 0";
	   minExtent = "8 2";
	   enabled = "1";
	   visible = "1";
	   clipToParent = "1";
	   color = "0 0 0 0";
	};
	PlayGUI.add(TeamspeakTalking);
	//MainMenuGUI.add(TeamspeakTalking);
	TeamspeakTalking.position = getWord(getRes(),0) - 205 SPC 25;
	TeamspeakTalking.extent = 180 SPC getWord(getRes(),1) - 50;
	%y = getWord(TeamspeakTalking.extent,1) - 32;
	%i = 0;
	while(%y >= 0)
	{
		%s = new GuiSwatchCtrl() {
		  profile = "GuiDefaultProfile";
		  horizSizing = "right";
		  vertSizing = "bottom";
		  position = 0 SPC %y;
		  extent = "180 32";
		  minExtent = "8 2";
		  enabled = "1";
		  visible = "0";
		  clipToParent = "1";
		  color = "0 0 0 0";
		  i = %i;
		  clid = -1;

		  new GuiBitmapCtrl() {
			 profile = "GuiDefaultProfile";
			 horizSizing = "right";
			 vertSizing = "bottom";
			 position = "0 0";
			 extent = "180 32";
			 minExtent = "8 2";
			 enabled = "1";
			 visible = "1";
			 clipToParent = "1";
			 wrap = "0";
			 lockAspectRatio = "0";
			 alignLeft = "0";
			 alignTop = "0";
			 overflowImage = "0";
			 keepCached = "0";
			 mColor = "255 255 255 255";
			 mMultiply = "0";
			 bitmap = "./back.png";
		  };
		  new GuiMLTextCtrl() {
			 profile = "BlockChatTextSize4Profile";
			 horizSizing = "right";
			 vertSizing = "bottom";
			 position = "10 5";
			 extent = "170 14";
			 minExtent = "8 2";
			 enabled = "1";
			 visible = "1";
			 clipToParent = "1";
			 text = "";
		  };
		};
		TeamspeakTalking.add(%s);
		%y -= 37;
		%i++;
	}
}

function setTeamspeakTalk(%clid, %isTalking)
{
	%count = TeamspeakTalking.getCount();
	if(%isTalking == 1)
	{

		for(%i = 0;%i < %count;%i++)
		{
			if(TeamspeakTalking.getObject(%i).visible == 0)
				break;
		}
		if(%i == %count)
		{
			//warn("Could not find open TeamspeakTalking!");
			return;
		}
		%obj = TeamspeakTalking.getObject(%i);
		%name = TSParseStr(findTSName(%clid));
		if(%name == -1)
		{
			//warn("Could not find Teamspeak name!");
			return;
		}
		%obj.setVisible(1);
		%obj.getObject(1).setText("<color:ffffff>" @ %name);
		%obj.clid = %clid;
	}
	else
	{
		%i = TSfindCLIDinGUI(%clid);
		if(%i == -1)
		{
			//warn("Could not find TeamspeakTalking with clid!");
			return;
		}
		%obj = TeamspeakTalking.getObject(%i);
		%obj.setVisible(0);
		%obj.clid = -1;
		
		//Code for waterfall talking
		//for(%i++;%i < %count;%i++)
		//{
		//	%curObj = TeamspeakTalking.getObject(%i);
		//	%oldObj = TeamspeakTalking.getObject(%i-1);
		//	%oldObj.getObject(1).setText(%curObj.getObject(1).getText());
		//	%oldObj.clid = %curObj.clid;
		//	if(%curObj.visible == 0)
		//	{
		//		%oldObj.setVisible(0);
		//		%oldObj.clid = -1;
		//		break;
		//	}
		//}
	}
}

function TSparseStr(%str)
{
	%str = strReplace(%str,"\\s"," ");
	%str = strReplace(%str,"\\p","|");
	%str = strReplace(%str,"\\n"," ");
	%str = strReplace(%str,"\\\/","/");
	if(strPos(%str,"[URL]") != -1)
	{

		if(strPos(%str,"ftp://") != -1)
		{
			%start = strPos(%str,"ftp://");
			%end = strPos(%str,"[/URL]"); 
			%link = getSubStr(%str, %start, %end - %start);
			%str = strReplace(%str,"ftp://","");
		}
		if(strPos(%str,"http://") != -1)
		{
			%start = strPos(%str,"http://");
			%end = strPos(%str,"[/URL]"); 
			%link = getSubStr(%str, %start, %end - %start);
			%str = strReplace(%str,"http://","");
		}
		if(strPos(%str,"https://") != -1)
		{
			%start = strPos(%str,"https://");
			%end = strPos(%str,"[/URL]"); 
			%link = getSubStr(%str, %start, %end - %start);
			%str = strReplace(%str,"https://","");
		}
		%str = strReplace(%str,"[URL]","<a:");
		%str = strReplace(%str,"[/URL]",">" @ %link @ "</a>");
	}
	%str = strReplace(%str,"[b]","");
	%str = strReplace(%str,"[/b]","");
	%str = strReplace(%str,"[i]","");
	%str = strReplace(%str,"[/i]","");
	%str = strReplace(%str,"[u]","");
	%str = strReplace(%str,"[/u]","");
	return %str;
}

function TSfindCLIDinGUI(%clid)
{
	%count = TeamspeakTalking.getCount();
	for(%i = 0;%i < %count;%i++)
	{
		if(TeamspeakTalking.getObject(%i).clid == %clid)
			return %i;
	}
	return -1;
}

function TSfindCLID(%clid)
{
	for(%i = 0;%i < teamspeakClients.count;%i++)
	{
		if(teamspeakClients.client[%i,"id"] == %clid)
			return %i;
	}
	return -1;
}

function findTSName(%clid)
{
	for(%i = 0;%i < teamspeakClients.count;%i++)
	{
		if(teamspeakClients.client[%i,"id"] == %clid)
			return teamspeakClients.client[%i,"name"];
	}
	return -1;
}	

function teamspeakMessage(%name, %msg, %pm)
{
	if($TS::chatMessages)
	{
		%msg = stripMLControlChars(%msg);
		if(!%pm)
			newChatHud_AddLine("\c4[Teamspeak]\c3" @ TSParseStr(%name) @ "\c6: " @ TSParseStr(%msg));
		else
			newChatHud_AddLine("\c4[Teamspeak]\c5[PM]\c3" @ TSParseStr(%name) @ "\c6: " @ TSParseStr(%msg));
	}
}

function buildChannelList(%channels)
{
	if(isObject(teamspeakChannels))
		teamspeakChannels.delete();
	new scriptObject(teamspeakChannels);
	%i = 0;
	while(strlen(%channels) > 1)
	{
		%tempChannels = strchr(%channels,"|");
		%chan = getSubStr(%channels,0,strLen(%channels)-strLen(%tempChannels));
		if(%tempChannels !$= "")
			%channels = getSubStr(%tempChannels,1,strLen(%tempChannels)-1);
		else
			%channels = "";
		teamspeakChannels.channel[%i,"id"] = strReplace(strReplace(getWord(%chan,0),"cid=",""),"\r","");
		teamspeakChannels.channel[%i,"name"] = strReplace(getWord(%chan,3),"channel_name=","");
		%i++;
	}
	teamspeakChannel.count = %i;
}

function buildClientList(%clients)
{
	//echo("building clist list");
	new scriptObject(newteamspeakClients);
	%i = 0;
	while(strlen(%clients) > 1)
	{
		%tempClients = strchr(%clients,"|");
		%cl = getSubStr(%clients,0,strLen(%clients)-strLen(%tempClients));
		if(%tempClients !$= "")
			%clients = getSubStr(%tempClients,1,strLen(%tempClients)-1);
		else
			%clients = "";
		newteamspeakClients.client[%i,"id"] = strReplace(strReplace(getWord(%cl,0),"clid=",""),"\r","");
		newteamspeakClients.client[%i,"name"] = strReplace(getWord(%cl,3),"client_nickname=","");
		%i++;
	}
	newteamspeakClients.count = %i;
	if(isObject(teamspeakClients))
	{
		%count = teamspeakTalking.getcount();
		for(%i=0;%i<%count;%i++)
		{
			%obj = teamspeakTalking.getObject(%i);
			if(TSfindCLID(%obj.clid) == -1)
			{
				%obj.setVisible(0);
				%obj.clid = -1;
			}
		}
		teamspeakClients.delete();
	}
	newteamspeakClients.setName(teamspeakClients);
}

function teamspeakConnect()
{
	teamspeakMM.enabled = 0;
	teamspeakMM.setBitmap("Add-ons/Client_Teamspeak/connecting");
	teamspeakCon.connect("localhost:25639");
}

//function clientCmdchangeTSChannel(%channel)
//{
//	for(%i = 0;%i < teamspeakChannels.count;$i++)
//	{
//	}
//}

schedule(10,0,initTeamspeakCon);